# language: ru

Функционал: Обновление рабочего каталога проекта 1С
    Как разработчик
    Я хочу иметь возможность обновить рабочий каталог проекта 1С
    Чтобы выполнять коллективную разработку проекта 1С

Контекст: Подготовка репозитория и рабочего каталога проекта 1С
    Дано я включаю отладку лога с именем "oscript.app.vanessa-runner"
    И Я очищаю параметры команды "oscript" в контексте

    Дано Я создаю временный каталог и сохраняю его в контекст
    И Я устанавливаю временный каталог как рабочий каталог
    И Я инициализирую репозиторий git в рабочем каталоге
    Дано Я создаю каталог "build/out" в рабочем каталоге
    И Я копирую каталог "cf" из каталога "tests/fixtures" проекта в рабочий каталог

    И Я установил рабочий каталог как текущий каталог
    Когда Я сохраняю каталог проекта в контекст

Сценарий: Инициализация и обновление рабочей базы по умолчанию в ./build/ib
    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os init-dev --src ./cf --nocacheuse --language ru"
    И Я очищаю параметры команды "oscript" в контексте

    Тогда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os update-dev --src ./cf --nocacheuse --language ru"
    И Я сообщаю вывод команды "oscript"
    Тогда Вывод команды "oscript" содержит "Обновление конфигурации базы данных успешно завершено"
    И Код возврата команды "oscript" равен 0

Сценарий: Инициализация и обновление рабочей базы  на сервере в режиме реструктуризации -v2
    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os init-dev --src ./cf --nocacheuse --language ru"
    И Я очищаю параметры команды "oscript" в контексте

    Тогда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os update-dev --src ./cf --nocacheuse --v2 --language ru"
    И Я сообщаю вывод команды "oscript"
    Тогда Вывод команды "oscript" содержит "Обновление конфигурации базы данных успешно завершено"
    И Код возврата команды "oscript" равен 0

Сценарий: Инициализация и обновление с инкрементальной загрузкой по логу GIT
    Когда Я выполняю команду "git" с параметрами "init"
        И я показываю вывод команды
        И Я очищаю параметры команды "git" в контексте
    Когда Я создаю файл ".gitignore" с текстом
        """
        lastUploadedCommit.txt
        build/ib/
        """
    Когда Я выполняю команду "git" с параметрами "add -A"
        И я показываю вывод команды
        И Я очищаю параметры команды "git" в контексте
    Когда Я выполняю команду "git" с параметрами 'commit -m "first commit"'
        И я показываю вывод команды
        И Я очищаю параметры команды "git" в контексте

    Дано я включаю отладку лога с именем "oscript.app.vanessa-runner"
    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os init-dev --src ./cf --nocacheuse --language ru"
    И я показываю вывод команды
    И Я очищаю параметры команды "oscript" в контексте

    Когда Я выполняю команду "git" с параметрами "rev-parse --short HEAD >> ./cf/lastUploadedCommit.txt"
        И я показываю вывод команды
        И Я очищаю параметры команды "git" в контексте
    Тогда Файл "./cf/lastUploadedCommit.txt" существует
    # И я показываю текст файла "./cf/lastUploadedCommit.txt"

    Когда Я выполняю команду "echo" с параметрами 'Сообщить("Управляемое приложение"); A=1; >> ./cf/Ext/ManagedApplicationModule.bsl'
    Когда Я выполняю команду "git" с параметрами "status"
        И я показываю вывод команды
    Тогда Вывод команды "git" содержит "modified:   cf/Ext/ManagedApplicationModule.bsl"
        И Я очищаю параметры команды "git" в контексте
    Когда Я выполняю команду "git" с параметрами "add -A"
        И я показываю вывод команды
        И Я очищаю параметры команды "git" в контексте
    Когда Я выполняю команду "git" с параметрами 'commit -m "second commit"'
        И я показываю вывод команды
        И Я очищаю параметры команды "git" в контексте

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os update-dev --src ./cf --nocacheuse --git-increment --language ru"
    И я показываю вывод команды
    Тогда Вывод команды "oscript" содержит "Будет выполнена инкрементальная загрузка"
        И Вывод команды "oscript" содержит "Измененные файлы:"
        И Вывод команды "oscript" содержит "ManagedApplicationModule.bsl"
        И Вывод команды "oscript" содержит "Обновление конфигурации базы данных успешно завершено"
        И Код возврата команды "oscript" равен 0

# TODO Сценарий: Инициализация сервисной базы по умолчанию в ./build/ibservice
# TODO Сценарий: Инициализация рабочей базы в отдельном каталоге
# TODO Сценарий: Инициализация сервисной базы в отдельном каталоге
