# language: ru

Функционал: Проверка разборки на исходники файла ./cf
	Как Разработчик/Инженер
	Я Хочу иметь возможность загружать файлы конфигурации
	Чтобы удостовериться в автоматизации сборки конфигурации из исходников

Контекст:
	И я удаляю каталог "build/cf"
	И я удаляю файл "build/1Cv8.cf"
	И Я очищаю параметры команды "oscript" в контексте

Сценарий: Первый - подготовка базы запуска
	Допустим я подготовил репозиторий и рабочий каталог проекта
	И я подготовил рабочую базу проекта "./build/ib" по умолчанию

Сценарий: Запуск разборки конфигурации из исходников в файл cf
	Дано Я добавляю параметр "<КаталогПроекта>/src/main.os compile" для команды "oscript"
	И Я добавляю параметр "-s ./cf" для команды "oscript"
	И Я добавляю параметр "-o ./build/1Cv8.cf" для команды "oscript"
    И Я добавляю параметр "--language ru" для команды "oscript"
	Когда Я выполняю команду "oscript"
	# И Я сообщаю вывод команды "oscript"
	Тогда Вывод команды "oscript" содержит
	| Сохранение конфигурации успешно завершено |
	И Код возврата команды "oscript" равен 0
	И Я очищаю параметры команды "oscript" в контексте

	И файл "build/1Cv8.cf" существует
	Дано Я создаю каталог "build/cf" в рабочем каталоге

	Дано Я добавляю параметр "<КаталогПроекта>/src/main.os decompile" для команды "oscript"
	И Я добавляю параметр "-i ./build/1Cv8.cf" для команды "oscript"
	И Я добавляю параметр "-o ./build/cf" для команды "oscript"
	И Я добавляю параметр "--ibconnection /F./build/ib" для команды "oscript"
    И Я добавляю параметр "--language ru" для команды "oscript"
	Когда Я выполняю команду "oscript"
	И я показываю вывод команды
	Тогда Вывод команды "oscript" содержит
	| Запускаю выгрузку конфигурации в исходники |
	| Выгрузка в исходники завершена |
	И каталог "build/cf" существует
	И файл "build/cf/Configuration.xml" существует

Сценарий: Запуск выгрузки конфигурации из текущей конфигурации
	Дано Я добавляю параметр "<КаталогПроекта>/src/main.os compile" для команды "oscript"
	И Я добавляю параметр "-s ./cf" для команды "oscript"
	И Я добавляю параметр "-c" для команды "oscript"
	И Я добавляю параметр "--ibconnection /F./build/ib" для команды "oscript"
    И Я добавляю параметр "--language ru" для команды "oscript"
	Когда Я выполняю команду "oscript"
	И я показываю вывод команды
	Тогда Вывод команды "oscript" содержит
	| Загрузка конфигурации из файлов успешно завершена |
	И Код возврата команды "oscript" равен 0
	И Я очищаю параметры команды "oscript" в контексте

	Дано Я создаю каталог "build/cf" в рабочем каталоге

	Дано Я добавляю параметр "<КаталогПроекта>/src/main.os decompile --ibconnection /F./build/ib" для команды "oscript"
	И Я добавляю параметр "--ibconnection /F./build/ib" для команды "oscript"
	И Я добавляю параметр "-c" для команды "oscript"
	И Я добавляю параметр "-o ./build/cf" для команды "oscript"
    И Я добавляю параметр "--language ru" для команды "oscript"

	Когда Я выполняю команду "oscript"
	И я показываю вывод команды
	Тогда Вывод команды "oscript" содержит
	| Запускаем разборку конфигурации текущей ИБ на исходники |
	| Выгрузка в исходники завершена |
	И каталог "build/cf" существует
	И файл "build/cf/Configuration.xml" существует
